﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win.SupportDialogs.FilterUIProvider;
using Infragistics.Win;

namespace WingridGroupBy
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraGrid1.DisplayLayout.Override.HeaderPlacement = HeaderPlacement.FixedOnTop;
            this.ultraGrid1.DisplayLayout.ViewStyleBand = ViewStyleBand.OutlookGroupBy;


            this.ultraGrid1.DisplayLayout.Bands[0].SortedColumns.Add("Column 0", false, true);
            this.ultraGrid1.Rows.ExpandAll(true);

            ultraGrid1.DisplayLayout.Bands[0].Columns["Column 1"].AllowRowFiltering = DefaultableBoolean.True;

            this.ultraGrid1.CreationFilter = new HideEmptGroupByRowCreationFilter();
        }

    }

    public class HideEmptGroupByRowCreationFilter : IUIElementCreationFilter
    {
        void IUIElementCreationFilter.AfterCreateChildElements(UIElement parent)
        {
            GroupByRowUIElement groupByRowUIElement = parent as GroupByRowUIElement;
            if (groupByRowUIElement != null)
            {
                if (groupByRowUIElement.GroupByRow.Rows.VisibleRowCount == 0)
                {
                    groupByRowUIElement.Parent.ChildElements.Remove(groupByRowUIElement);
                }
            }
        }

        bool IUIElementCreationFilter.BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }

}
